TYPO3.Flow - Bug # 33883

Status: Resolved Priority: Should have
Author: Kira Backes Category: Persistence
Created: 2012-02-13 Assigned To: Karsten Dambekalns
Updated: 2012-05-03 Due date:

PHP Version:

Has patch: No

Complexity:

Affected Flow version: Git master

Subject: Repositories must be singleton, but no checks are done on this

Description

| have models with injected repositories and due to some change in the last 2 weeks in master | can no longer use FLOWS, since the
following error comes up:

Undefined method 'getDefaultOrderings'. The method name must start with either findBy or findOneBy!

This was tracable to the fact that \TYPO3\FLOWB3\Reflection\ObjectAccess::isPropertyGettable checks for is_callable, which returns
true for every method in Repositories (due to the magic __call method) which in turn causes
\TYPO3\FLOW3\Validation\Validator\GenericObjectValidator::getPropertyValue to not use the direct property access, even though it
would be needed.

Related issues:
related to TYPO3.Media - Bug # 33564: Persisting image throws Exception Resolved 2012-01-31

Associated revisions

Revision 5342192 - 2012-04-30 16:10 - Karsten Dambekalns
[BUGFIX] Check that repositories are of singleton scope
Repositories must be singletons, otherwise strange things and
seemingly weird errors happen. This change adds a check for the
scope, so that developers at least know what is wrong.
Change-Id: 1c3782452e941574dd85068535092877efd7ca190

Fixes: #33883
Releases: 1.1

Revision cfbc8fa0 - 2012-05-03 10:13 - Sebastian Kurfuerst

[BUGFIX] (Persistence): Fix failing Repository Test

The test fails since 1c3782452e941574dd85068535092877efd7ca190 which
forgot to adjust the Unit Tests.

Change-Id: 13be86c157afd345bad310aa03d9ba2276c2a8350

Related: #33883
Releases: 1.1
History

#1 - 2012-02-14 10:17 - Kira Backes

It is "fixable" by setting the scope of the repositories to Singleton

#2 - 2012-02-16 11:27 - Karsten Dambekalns

- Subject changed from ObjectValidation fails, partially unusable system to Repositories must be singleton, but no checks are done on this
- Category set to Persistence

- Status changed from New to Accepted

- Assigned To set to Karsten Dambekalns

- Priority changed from Must have to Should have

- Target version set to 1.1

Well, repositories must be singleton, otherwise | don't even want to imagine what happens...

| changed the bug title accordingly.

#3 - 2012-04-30 16:10 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10899

#4 - 2012-05-03 14:40 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:5e342192819640b75bb54f86873622e537af810b.
